<template>
  <div class="purchaseOrder pagePadding">
    <ex-table
      v-loading="loading"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @selection="selection_change"
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 0 80px">
            <el-col :span="4" style="width: 150px">
              <el-select
                :size="searchSize"
                v-model="parmValue.status"
                filterable
                clearable
                placeholder="销售订单状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusOptions"
                  :key="'status' + item.value"
                  :label="item.label"
                  :value="item.value"
                />
              </el-select>
            </el-col>

            <el-col :span="4" style="width: 110px; padding: 0 0 0 10px">
              <el-dropdown @command="handleClick($event)" :size="searchSize">
                <el-button :size="searchSize" style="width: 100px">
                  {{ sselect }}
                  <i class="el-icon-arrow-down el-icon--right" :size="searchSize"></i>
                </el-button>
                <el-dropdown-menu slot="dropdown">
                  <el-dropdown-item v-for="item in options" :key="item" :command="item">{{
                    item
                  }}</el-dropdown-item>
                </el-dropdown-menu>
              </el-dropdown>
            </el-col>
            <el-col :span="4" style="width: 303px; padding: 0 0 0 10px">
              <period-date-picker
                :type="1"
                :width="'135px'"
                :size="searchSize"
                :start="timeOBJ.start"
                :end="timeOBJ.end"
                @timeReturned="handleTime"
              />
            </el-col>
            <el-col :span="3" style="width: 66px; float: right">
              <el-button
                :size="searchSize"
                type="primary"
                style="float: right; margin-left: 5px"
                @click="searchList"
              >
                刷新
              </el-button>
            </el-col>
            <el-col :span="4" style="width: 66px; float: right">
              <el-button type="warning" class="fr" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>
          <el-row style="padding: 10px 0 0 0">
            <el-col :span="6" style="width: 500px; padding: 0 0 0 0px">
              <el-input
                clearable
                placeholder="关键字"
                v-model="input"
                maxlength="40"
                :size="searchSize"
                class="input-with-select"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-select
                  v-model="select"
                  style="width: 125px"
                  slot="prepend"
                  placeholder="关键字类型"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option label="销售订单编号" value="1"></el-option>
                  <el-option label="商品编号" value="4"></el-option>
                  <el-option label="商品名称" value="5"></el-option>
                </el-select>
              </el-input>
            </el-col>

            <el-col :span="4" style="width: 90px; float: right">
              <el-button
                type="primary"
                style="margin-left: 30px"
                @click="download"
                :size="searchSize"
                class="fr"
              >
                批量导出
              </el-button>
            </el-col>
            <el-col :span="4" style="width: 90px; float: right">
              <el-button
                type="primary"
                @click="statusConfirmIn"
                :size="searchSize"
                class="fr"
              >
                批量入库
              </el-button>
            </el-col>
            <el-col :span="4" style="width: 90px; float: right">
              <el-button
                type="primary"
                @click="statusConfirm"
                :size="searchSize"
                class="fr"
              >
                批量确认
              </el-button>
            </el-col>
          </el-row>
        </div>
      </template>
      <template #good_name="{ scope }">
        <span>{{ scope.row.good_name }}</span>
        <span v-for="(si, i) in scope.row.speclist" :key="si.spec_id + i">
          {{ i === 0 ? "__" : "--" }}{{ si.spec_name }}[{{ si.spec_value }}]
        </span>
      </template>
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          v-text="
            (statusOptions.find((item) => item.value == scope.row.status) || {}).label ||
            '--'
          "
        ></el-tag>
      </template>
      <template #order_id="{ scope }">
        <el-tag
          :size="tablebtnSize"
          v-text="
            (cg_order_type_options.find((item) => item.id == scope.row.order_type) || {})
              .label || '--'
          "
        ></el-tag>
      </template>
      <template #operation="{ scope }">
        <el-tooltip effect="dark" content="详情" placement="top">
          <i
            class="el-icon-view tb-icon"
            @click="getRouter('/purchaseOrder/pDetail', scope.row.cgdNo)"
          ></i>
        </el-tooltip>
      </template>
    </ex-table>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import urlConfig from "@/apis/url-config";
import asyncRequest from "@/apis/purchaseOrder";
import { columns, statusOptions } from "./columns";
import { cg_order_type_options } from "@/assets/js/statusList";
import { mapGetters } from "vuex";

export default {
  name: "purchaseOrder",
  mixins: [mixinPage, resToken],
  components: {},
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size", "business_companyNo"]),
    maxNo() {
      return this.business_companyNo;
    },
  },

  watch: {
    maxNo(val, oldval) {
      this.restSearch();
      // console.log(val, oldval);
    },
  },
  data() {
    return {
      //入库公司
      supplierName: "",
      cg_order_type_options,
      //入库仓库
      stockName: "",
      changeList: [],
      fileUrl: urlConfig.baseURL,
      sitem: null,
      select: "1",
      input: "",
      timeOBJ: {
        start: "", //起始时间
        end: "", // 结束时间
      },
      options: ["创建时间", "最晚入库时间"],
      sselect: "创建时间",
      // 状态
      statusOptions: statusOptions,
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      wsm_code: [],
      wsm_supplierNo: [],
      parmValue: {
        orderCode: "", // 订单编号
        bk_code: "", // 备库编码
        wsm_in_code: "", // 入库单号
        cgdNo: "", // 销售订单编码
        apply_name: "", // 申请人
        good_name: "", // 产品名称
        good_code: "", // 产品属性编号

        status: "", //状态

        wsm_code: "", //入货仓库编码
        start: "", //新建起始时间
        end: "", // 新建结束时间
        last_start: "", //最后入库时间开始
        last_end: "", //最后入库时间结束
        page: 1, // 页码
        size: 15, // 每页显示条数
        company_name: "", //部门
        wsm_supplierNo: "",
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue);
      const { page, size, start, end, last_start, last_end } = this.parmValue;
      this.timeOBJ.start = start || last_start;
      this.timeOBJ.end = end || last_end;

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      this.sselect = this.parmValue.sselect;
      this.input = this.parmValue.input;
    } else {
      this.select = "1";
      this.sselect = "创建时间";
    }
    this.searchList();
  },

  methods: {
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
        };

        //有多选框的条件
        this.parmValue.select = this.select;
        this.parmValue.sselect = this.sselect;
        this.parmValue.input = this.input;

        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    //选中触发函数
    selection_change(e) {
      const { list } = e;
      //选中的数组集合
      this.changeList = list.length > 0 ? JSON.parse(JSON.stringify(list)) : [];
    },
    //导出文件
    async download() {
      if (this.loading) return;
      if (this.changeList.length <= 0) {
        this.$message.warning("请选择有效数据");
        return;
      }
      this.loading = true;
      const url = this.fileUrl + "abutment/exportCgdList",
        httpType = `aplication/zip`,
        excelName = "销售订单.zip";
      let model = {
        cgdNos: [],
      };
      this.changeList.forEach((item) => {
        model.cgdNos.push(item.cgdNo);
      });
      const { code } = await this.pageHttpDownload(url, model, httpType, excelName);
      if (code === 0) {
        this.$message.success(`销售订单导出成功！`);
      } else {
        this.$message.success(`销售订单导出失败！`);
      }
      setTimeout(() => {
        this.loading = false;
      }, 500);
    },

    async statusConfirm() {
      if (this.changeList.length <= 0) {
        this.$message.warning("至少选择一条销售订单数据！");
        return;
      }
      let isok = true,
        list = [];
      this.changeList.forEach((e) => {
        if (e.status !== "0") {
          isok = false;
        }
        list.push(e.cgdNo);
      });
      if (!isok) {
        this.$message.warning("只能选择未确认的销售订单！");
        return;
      }
      await this.$confirm(`确定批量确认？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          let model = {
            cgdNo: list,
            status: "1",
          };
          const res = await asyncRequest.status(model);
          const { code } = await this.useResHandle(res);
          this.loading = false;
          if (code === 0) {
            this.$notify.success({
              title: "提交成功！",
              message: "",
            });
            await this.searchList();
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async statusConfirmIn() {
      if (this.changeList.length <= 0) {
        this.$message.warning("至少选择一条销售订单数据！");
        return;
      }
      let isok = true,
        list = [];
      this.changeList.forEach((e) => {
        if (!(e.status === "1" || e.status === "2")) {
          isok = false;
        }
        list.push(e.cgdNo);
      });
      if (!isok) {
        this.$message.warning("只能选择未入库的销售订单！");
        return;
      }
      await this.$confirm(`确定批量入库？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          let model = {
            cgdNo: list,
            // status: "3",
          };
          const res = await asyncRequest.addOrderIn(model);
          const { code, data, message } = await this.useResHandle(res, true);
          this.loading = false;
          if (code === 0) {
            this.$notify.success({
              title: "提交成功！",
              message: "",
            });
            await this.searchList();
          } else if (code == 1003) {
            this.showal(data, message, "");
          } else {
            this.$message.warning(message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },

    showal(list, message, code) {
      let htmlList = "<ul>";
      list.forEach((v) => {
        htmlList += `<li>${code !== "" ? v[code] : v}</li>`;
      });
      htmlList += "</ul>";
      this.$notify({
        title: message,
        dangerouslyUseHTMLString: true,
        message: htmlList,
      });
    },
    restSearch() {
      this.sselect = "创建时间";
      this.select = "1";
      this.input = "";
      this.wsm_code = [];
      this.wsm_supplierNo = [];
      this.timeOBJ = {
        start: "", //起始时间
        end: "", // 结束时间
      };
      this.parmValue = {
        bk_code: "", // 备库编码
        wsm_in_code: "", // 入库单号
        cgdNo: "", // 销售订单编码
        apply_name: "", // 申请人
        good_name: "", // 产品名称
        good_code: "", // 产品属性编号
        status: "", //状态
        wsm_code: "", //入货仓库编码
        start: "", //新建起始时间
        end: "", // 新建结束时间
        last_start: "", //最后入库时间开始
        last_end: "", //最后入库时间结束
        orderCode: "", //订单编号
        company_name: "", //部门
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },
    async handleClick(e) {
      this.sselect = e;
      this.parmValue.start = e === "创建时间" ? this.timeOBJ.start : "";
      this.parmValue.end = e === "创建时间" ? this.timeOBJ.end : "";
      this.parmValue.last_start = e !== "创建时间" ? this.timeOBJ.start : "";
      this.parmValue.last_end = e !== "创建时间" ? this.timeOBJ.end : "";
      if (
        !(
          (this.timeOBJ.start !== "" && this.timeOBJ.end === "") ||
          (this.timeOBJ.start === "" && this.timeOBJ.end !== "")
        )
      ) {
        this.parmValue.page = 1;
        this.pageInfo.curr = 1;
        await this.searchList();
      }
    },

    async searchList() {
      if (this.loading) return;

      if (
        (this.timeOBJ.start !== "" && this.timeOBJ.end === "") ||
        (this.timeOBJ.start === "" && this.timeOBJ.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }

      this.loading = true;
      this.parmValue.cgdNo = this.select === "1" ? this.input : ""; // 销售订单编码
      this.parmValue.good_code = this.select === "4" ? this.input : ""; // 产品属性编号
      this.parmValue.good_name = this.select === "5" ? this.input : ""; // 产品名称
      console.log(this.pageInfo);
      // this.wsm_supplierNo = [];
      const res = await asyncRequest.list(this.parmValue);
      const { code, data } = await this.useResHandle(res);
      if (code === 0) {
        const { list, count } = data;
        this.tableData = list;
        this.pageInfo.total = Number(count);
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
    // 时间
    async handleTime(e) {
      this.timeOBJ.start = e?.startTime ?? "";
      this.timeOBJ.end = e?.endTime ?? "";
      await this.handleClick(this.sselect);
    },
  },
};
</script>
<style lang="scss" scoped>
.purchaseOrder {
  // text-align: right;
}
</style>
